/*
    EditCustomer2.prg
    Author ...: Ken Mayer
    Date .....: May, 2004
    Notes:
       Edit the customer data. This is the program called to
       find the row, and save the changes made in the
       EditCustomer screen ...
    
    Calls:       DisplayCustomers.dbw, index.htm
    Called from: DisplayCustomers.prg

    Purpose: This is a demonstration of code using dBASE to create
             web applications, created for dBCon 2004. This code
             may be used, modified as needed, etc. for your own
             application, but please give credit where credit is
             due.
*/

// This "included" program handles the initialization of the
// CGI object, the setup of the data, and also handles the
// HTML header and the page title tags ...:
#INCLUDE <GSCustomerStartCode.prg>

// we should have a parameter and we need to try to find
// the value passed:
try

   if not rCustomer.applyLocate( "CustomerNum="+oCGI["CustomerNum"] )
      oCGI.sorryPage( "Customer Number: "+oCGI["CustomerNum"]+" was not found ..." )
      quit
   else
      rCustomer.filter = "CustomerNum="+val( oCGI["CustomerNum"] )
   endif


catch( Exception E )

   oCGI.errorPage( e )

endtry


try

   // Before actually creating any sort of output,
   // we should attempt to save the data -- NOTE that
   // this is a good place to do any validation
   // you might wish to do ... Remember: Associative
   // arrays are case sensitive!

   // ----------- Validation of Data ---------------
   // This is the spot to do that -- before we try
   // actually updating anything ...
   // For this example, the only real validation
   // I'm going to do is make sure the first and
   // last names are filled in. You can get as complex
   // as you need to.
   if empty( oCGI["FirstName"] )
      oCGI.sorryPage( "Customer First Name is required! It cannot be left empty.",;
                      "Data Error" )
      quit
   endif
   if empty( oCGI["LastName"] )
      oCGI.sorryPage( "Customer Last Name is required! It cannot be left empty.",;
                      "Data Error" )
      quit
   endif

   // now to actually attempt to save the data ...:
   rCustomer.beginEdit()

   // the way we do this is assign values for fields
   // from the CGI array, in most cases. When we get to
   // the radiobuttons and checkboxes it's a little
   // different:
   fCustomer["FirstName"].value    := oCGI["FirstName"]
   fCustomer["LastName"].value     := oCGI["LastName"]
   fCustomer["Address1"].value     := oCGI["Address1"]
   fCustomer["Address2"].value     := oCGI["Address2"]
   fCustomer["City"].value         := oCGI["City"]
   fCustomer["State"].value        := oCGI["State"]
   fCustomer["Country"].value      := oCGI["Country"]
   fCustomer["PostalCode"].value   := oCGI["PostalCode"]
   fCustomer["PhoneNumber"].value  := oCGI["PhoneNumber"]
   fCustomer["EMailAddress"].value := oCGI["EMailAddress"]


   // now we deal with the logical fields, which were done
   // using checkboxes. CGI handles checkboxes differently
   // than entryfields -- if the value is returned, the
   // checkbox was checked, if not, it was unchecked. There
   // is no null value here -- it's either considered to be
   // true or false:
   fCustomer["ContactViaEMail"].value  := oCGI.isKey( "ContactViaEMail" )
   fCustomer["ContactViaPhone"].value  := oCGI.isKey( "ContactViaPhone" )
   fCustomer["ContactViaPostal"].value := oCGI.isKey( "ContactViaPostal" )

   // Radiobuttons -- in this case, the "MaleFemale" ('sex') buttons:
   // In this case CGI returns the 'value' of the selected
   // radiobutton:
   fCustomer["MaleFemale"].value := oCGI["MaleFemale"]

   // Next we have values from a listbox:
   // Lisboxes return the 'selected' value:
   fCustomer["AgeGroup"].value   := oCGI["AgeGroup"]

   // and finally, the notes/memo field -- taken from
   // a textarea -- note, if it's empty it is not
   // passed:
   if oCGI.isKey( "Notes" )
      fCustomer["Notes"].value       := oCGI["Notes"]
   endif

   // save everything:
   rCustomer.save()

   // The Response Page:
   // First some really basic stuff (center, some title stuff, 
   // end/center):
   oCGI.cOutString += [<center><font size="+2">Data Saved</font><br>]
   oCGI.cOutString += [Date: ]+date()+[</center>]
   oCGI.cOutString += [<p>]

   // give the user some options as to what to do ...
   // (html links to DisplayCustomers and index.htm ...)
   oCGI.cOutString += [<p><hr><p>]
   oCGI.cOutString += [<center>]
   oCGI.cOutString += [<a href="DisplayCustomers.dbw">View/Edit Another?</a>]
   oCGI.cOutString += [&nbsp;&nbsp;&nbsp;]
   oCGI.cOutString += [<a href="../index.htm">Back to Main Menu</a>]
   oCGI.cOutString += [</center>]

   // stream the whole thing out:
   oCGI.streamDetail( oCGI.cOutString )

   // the standard footer:
   oCGI.streamFooter()

   // quit:
   quit

catch( Exception E )

   oCGI.errorPage( e )

endtry
// --------------------------------------------------------------------
// End of program: EditCustomers.prg
// --------------------------------------------------------------------

