/*
    GS_WebClass.cc -- this is a subclass of the :webwizards:WebClass.cc
    that ships with dBASE Plus, and is used in the sample application
    for dBCon 2004 created by Ken Mayer. 

    You may use this code if you wish, although frankly it is designed
    as a learning tool more than a real-world application ... KJM

    Note: This class is based loosely on code found in the dBASE Users'
    Function Library Project (dUFLP), the file is kenWebClass.cc ...
*/

// define the class:
class GS_WebClass of CGISession from :webwizards:webclass.cc

   // Instantiate the output string used by
   // both methods here, and in code using this class ...
   this.cOutString = ""

   // -----------------------------------------------------------------
   // Overridden code from :WebWizards:WebClass.cc
   // -----------------------------------------------------------------
   // streamFooter is an overwritten method:
   function streamFooter()
      /*
         Stream a footer with "Powered by dBASE" image:
      */
      this.streamDetail( "<p>" )
      this.streamDetail( "<hr>" )
      this.streamDetail( "<p>" )
      this.streamDetail( [<a href="http://www.dbase.com">] )
      this.streamDetail( [<img src="PoweredBydBASE.gif" border="0" align="absmiddle" alt="dBASE Plus">] )
      this.streamDetail( [</a>] )
      this.streamDetail( "" )
      this.streamDetail( "</body>" )
      this.streamDetail( "</html>" )
   // end of method: streamFooter

   // -----------------------------------------------------------------
   // The following are new methods that are not in the class
   // CGISession in :WebWizards:WebClass.cc
   // -----------------------------------------------------------------
   function getTitle( cTitle )
      /*
          getTitle is used to create a title that works
          like the one in the primary webclass for the sorryPage
          and errorPage methods ... it's simply done with
          the use of a table and setting the background for
          the cell in the table. 
      */

      // Title, includes staghead.bmp image:
      this.cOutString += [<center><table>]
      this.cOutString += [<tr align="center"><td>]
      this.cOutString += [<img src="StagHead.bmp" align="right" valign="top" height="150">]
      this.cOutString += [<font color="DarkGreen" size="+3">]
      this.cOutString += [<i>Golden Stag Productions</i>]
      this.cOutString += [</font>]
      this.cOutString += [<br>]
      this.cOutString += [<font size="+1">Sales Department<br>]
      this.cOutString += [Customer Data</font>]
      this.cOutString += [</td></tr>]
      this.cOutString += [</table></center>]
      this.cOutString += [<hr>]

      // Blank Line:
      this.cOutString += [<p>] 
   // end of method: getTitle      

   function streamDetail( cString )
      // cString is the string you want streamed out -- it can
      // contain HTML ...
      // NOTE: This should be called after the streamHeader()
      // and streamBody() methods are called ...
      this.fOut.puts( ""+cString )
   // end of method: streamDetail

   // getFormBegin streams out the form tag
   function getFormBegin( cCGI )
       /*
          The form tag needs to know what to do when
          the user submits it, hence the "cCGI" parameter ... 
          if this is left out, the form will not actually
          do anything if you click the submit button ... it will
          work, but ...

          Your CGI/Action ought to be something like:
             "/cgi-bin/myprog.exe" 
       */
      cOut = [<FORM METHOD="POST" ]
      if pCount() => 1
         cOut += [ACTION="]+cCGI+[" enctype="application/x-www-form-urlencoded"]
      endif
      cOut += [>]

      this.cOutString += cOut
   // end of method: streamFormBegin

   // This is the Customer Data screen, used in the Add and Edit
   // modules:
   function getCustomerScreen
       // cType should be either 'Edit' or it should be 'Add'
       // if 'edit' we need to set the appropriate values for
       // the various controls using the data in the currently
       // selected row. This code has to assume that we have dealt
       // with finding the row and that the row pointer is currently
       // on the row we want to edit.
       // If adding a new row, we can set any defaults we might
       // want to set, and that should be it:
       parameter cType

       // first, a table:
       this.cOutString +=  [<table border="1" width="100%">]

       // For this to work in a sensible fashion, we're going
       // to output the data with each field being in its own
       // row of the HTML table. It just makes it easier ...
       // hopefully this will make sense as you see it.

       // if we're editing a row, let's display the customer
       // number:
       if cType == "Edit"
          this.cOutString +=  [<tr valign="top">]
          this.cOutString +=  [<td align="right">Customer Number: </td>]
          this.cOutString +=  [<td>]+fCustomer["CustomerNum"].value+[</td>]
          this.cOutString +=  [</tr>]

          // we also need to create a hidden value that can
          // be passed invisibly to the next program:
          this.cOutString += [<input type="hidden" name="CustomerNum" value="]+;
                             fCustomer["CustomerNum"].value+;
                             [">]
       endif

       // Next the name fields:
       // First Name:
       this.cOutString +=  [<tr valign="top">]
       this.cOutString +=  [<td align="right">First Name: </td>]
       this.cOutString +=  [<td>]
       // create the entryfield, but we need to check to see
       // what's up -- if we're editing we need to pass the
       // current value ...:
       this.cOutString +=  [<input type="text" name="FirstName" size="20" maxlength="20"]+;
          iif( cType == "Edit", [ value="]+fCustomer["FirstName"].value.rightTrim()+["], "" )+;
          [>]
       this.cOutString +=  [</td>]
       this.cOutString +=  [</tr>]
       // Last Name:
       this.cOutString +=  [<tr valign="top">]
       this.cOutString +=  [<td align="right">Last Name: </td>]
       this.cOutString +=  [<td>]
       // create the entryfield, but we need to check to see
       // what's up -- if we're editing we need to pass the
       // current value ...:
       this.cOutString +=  [<input type="text" name="LastName" size="20" maxlength="20"]+;
          iif( cType == "Edit", [ value="]+fCustomer["LastName"].value.rightTrim()+["], "" )+;
          [>]
       this.cOutString +=  [</td>]
       this.cOutString +=  [</tr>]

       // Address:
       this.cOutString +=  [<tr valign="top">]
       this.cOutString +=  [<td align="right">Street Address: </td>]
       this.cOutString +=  [<td>]
       // For this we're going to put one heading, but 
       // two 'entryfields' in the same cell of the table, with
       // a break between them:
       this.cOutString +=  [<input type="text" name="Address1" size="30" maxlength="30"]+;
          iif( cType == "Edit", [ value="]+fCustomer["Address1"].value.rightTrim()+["], "" )+;
          [><br>]
       this.cOutString +=  [<input type="text" name="Address2" size="30" maxlength="30"]+;
          iif( cType == "Edit", [ value="]+fCustomer["Address2"].value.rightTrim()+["], "" )+;
          [>]
       this.cOutString +=  [</td>]
       this.cOutString +=  [</tr>]

       // City:
       this.cOutString +=  [<tr valign="top">]
       this.cOutString +=  [<td align="right">City: </td>]
       this.cOutString +=  [<td>]
       this.cOutString +=  [<input type="text" name="City" size="30" maxlength="30"]+;
          iif( cType == "Edit", [ value="]+fCustomer["City"].value.rightTrim()+["], "" )+;
          [>]
       this.cOutString +=  [</td>]
       this.cOutString +=  [</tr>]

       // State:
       this.cOutString +=  [<tr valign="top">]
       this.cOutString +=  [<td align="right">State (if in US): </td>]
       this.cOutString +=  [<td>]
       this.cOutString +=  [<input type="text" name="State" size="2" maxlength="2"]+;
          iif( cType == "Edit", [ value="]+fCustomer["State"].value.rightTrim()+["], "" )+;
          [>]
       this.cOutString +=  [</td>]
       this.cOutString +=  [</tr>]

       // Country:
       this.cOutString +=  [<tr valign="top">]
       this.cOutString +=  [<td align="right">Country: </td>]
       this.cOutString +=  [<td>]
       this.cOutString +=  [<input type="text" name="Country" size="20" maxlength="20"]+;
          iif( cType == "Edit", [ value="]+fCustomer["Country"].value.rightTrim()+["], "" )+;
          [>]
       this.cOutString +=  [</td>]
       this.cOutString +=  [</tr>]

       // Postal Code:
       this.cOutString +=  [<tr valign="top">]
       this.cOutString +=  [<td align="right">Postal Code: </td>]
       this.cOutString +=  [<td>]
       this.cOutString +=  [<input type="text" name="PostalCode" size="10" maxlength="10"]+;
          iif( cType == "Edit", [ value="]+fCustomer["PostalCode"].value.rightTrim()+["], "" )+;
          [>]
       this.cOutString +=  [</td>]
       this.cOutString +=  [</tr>]

       // Phone:
       this.cOutString +=  [<tr valign="top">]
       this.cOutString +=  [<td align="right">Phone Number: </td>]
       this.cOutString +=  [<td>]
       this.cOutString +=  [<input type="text" name="PhoneNumber" size="14" maxlength="14"]+;
          iif( cType == "Edit", [ value="]+fCustomer["PhoneNumber"].value.rightTrim()+["], "" )+;
          [>]
       this.cOutString +=  [</td>]
       this.cOutString +=  [</tr>]

       // EMail:
       this.cOutString +=  [<tr valign="top">]
       this.cOutString +=  [<td align="right">EMail Address: </td>]
       this.cOutString +=  [<td>]
       this.cOutString +=  [<input type="text" name="EMailAddress" size="50" maxlength="50"]+;
          iif( cType == "Edit", [ value="]+fCustomer["EMailAddress"].value.rightTrim()+["], "" )+;
          [>]
       this.cOutString +=  [</td>]
       this.cOutString +=  [</tr>]

       // Contact via EMail? -- the next three items are
       // checkboxes, and must be handled differently!
       this.cOutString +=  [<tr valign="top">]
       // skip the first column:
       this.cOutString +=  [<td></td>]
       this.cOutString +=  [<td>]      
       // if the value of the field is true (and we're editing), we need to
       // set the checkbox's 'checked' property ...
       this.cOutString +=  [<input type="checkbox" name="ContactViaEMail"]+;
          iif( cType == "Edit", iif( fCustomer["ContactViaEMail"].value," checked", "" ),"")+;
          [> Contact via EMail?]
       this.cOutString +=  [</td>]
       this.cOutString +=  [</tr>]

       // Contact via Phone?
       this.cOutString +=  [<tr valign="top">]
       // skip the first column:
       this.cOutString +=  [<td></td>]
       this.cOutString +=  [<td>]      
       // if the value of the field is true (and we're editing), we need to
       // set the checkbox's 'checked' property ...
       this.cOutString +=  [<input type="checkbox" name="ContactViaPhone"]+;
          iif( cType == "Edit", iif( fCustomer["ContactViaPhone"].value," checked", "" ),"")+;
          [> Contact via Phone?]
       this.cOutString +=  [</td>]
       this.cOutString +=  [</tr>]

       // Contact via Mail?
       this.cOutString +=  [<tr valign="top">]
       // skip the first column:
       this.cOutString +=  [<td></td>]
       this.cOutString +=  [<td>]      
       // if the value of the field is true (and we're editing), we need to
       // set the checkbox's 'checked' property ...
       this.cOutString +=  [<input type="checkbox" name="ContactViaPostal"]+;
          iif( cType == "Edit", iif( fCustomer["ContactViaPostal"].value," checked", "" ),"")+;
          [> Contact via (Postal) Mail?]
       this.cOutString +=  [</td>]
       this.cOutString +=  [</tr>]

       // Male/Female?
       this.cOutString +=  [<tr valign="top">]
       this.cOutString +=  [<td align="right">Select Sex:</td>]
       this.cOutString +=  [<td>]      
       // we're going to do a pair of radiobuttons for this:
       this.cOutString +=  [<input type="radio" name="MaleFemale" value="M"]+;
          iif( cType == "Edit", iif( fCustomer["MaleFemale"].value=="M"," checked", "" )," checked")+;
          [> Male<br>]
       this.cOutString +=  [<input type="radio" name="MaleFemale" value="F"]+;
          iif( cType == "Edit", iif( fCustomer["MaleFemale"].value=="F"," checked", "" ),"")+;
          [> Female<br>]
       this.cOutString +=  [</td>]
       this.cOutString +=  [</tr>]

       // More demographic stuff, age group:
       this.cOutString +=  [<tr valign="top">]
       this.cOutString +=  [<td align="right">Age Group:</td>]
       this.cOutString +=  [<td>]      
       // we're going to do a 'listbox' for this:
       this.cOutString +=  [<select name="AgeGroup" size="5">]
       this.cOutString +=  [<option]+;
                          iif( fCustomer["AgeGroup"].value.rightTrim()=="1-17",;
                          " selected","")+[ value="1-17">1-17]
       this.cOutString +=  [<option]+;
                          iif( fCustomer["AgeGroup"].value.rightTrim()=="18-35",;
                          " selected","")+[ value="18-35">18-35]
       this.cOutString +=  [<option]+;
                          iif( fCustomer["AgeGroup"].value.rightTrim()=="36-44",;
                          " selected","")+[ value="36-44">36-44]
       this.cOutString +=  [<option]+;
                          iif( fCustomer["AgeGroup"].value.rightTrim()=="45-60",;
                          " selected","")+[ value="45-60">45-60]
       this.cOutString +=  [<option]+;
                          iif( fCustomer["AgeGroup"].value.rightTrim()=="60+",;
                          " selected","")+[ value="60+">60+]
       this.cOutString +=  [</select>]
       this.cOutString +=  [</td>]
       this.cOutString +=  [</tr>]

       // The notes field:
       this.cOutString +=  [<tr valign="top">]
       this.cOutString +=  [<td align="right">Notes:</td>]
       this.cOutString +=  [<td>]      
       // we're going to do an 'editor' for this:
       this.cOutString +=  [<textarea name="Notes" rows=4 cols=70>]
       if cType=="Edit"
          this.cOutString +=  fCustomer["Notes"].value.rightTrim()
       endif
       this.cOutString +=  [</textarea>]
       this.cOutString +=  [</td>]
       this.cOutString +=  [</tr>]

       // finally let's end the table:
       this.cOutString +=  [</table>]
       this.cOutString +=  [<p>]

   // end of method: streamCustomerScreen


endclass

